<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_25) on Tue Nov 07 17:08:40 PST 2017 -->
<title>Setters</title>
<meta name="date" content="2017-11-07">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Setters";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../xdc/services/getset/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../xdc/services/getset/Scheduler.html" title="class in xdc.services.getset"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?xdc/services/getset/Setters.html" target="_top">Frames</a></li>
<li><a href="Setters.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields_inherited_from_class_org.mozilla.javascript.ScriptableObject">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">xdc.services.getset</div>
<h2 title="Class Setters" class="title">Class Setters</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>org.mozilla.javascript.ScriptableObject</li>
<li>
<ul class="inheritance">
<li>org.mozilla.javascript.IdScriptableObject</li>
<li>
<ul class="inheritance">
<li>org.mozilla.javascript.BaseFunction</li>
<li>
<ul class="inheritance">
<li>xdc.services.getset.Setters</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.io.Serializable, org.mozilla.javascript.Callable, org.mozilla.javascript.ConstProperties, org.mozilla.javascript.debug.DebuggableObject, org.mozilla.javascript.Function, org.mozilla.javascript.IdFunctionCall, org.mozilla.javascript.Scriptable</dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">Setters</span>
extends org.mozilla.javascript.BaseFunction</pre>
<div class="block">A setter function to be added to a field of an XDCscript
 Value.Obj object. The Setters service manages a set of user-defined
 setter functions that notifies client code of a change to the value of
 the field. The setter only fires on writes to the field that
 actually change its value. Writing the current value again doesn't fire
 the setter.<p/>
 
 There is also a set of global user-defined setter functions that are
 notified on any change. This avoids having to manually add such setters
 to every field. Note, though, that the global setters only apply to
 fields that have had the Setters service added to them.<p/>
 
 Exceptions thrown by a setter are handled as follows:
     - the original value of the config is restored (without triggering
       any setters)
     - any setters for the config called before the exception are called
       again with the old and new values reversed and an additional
       exception object (passed as a forth argument)
     - calls to any setters that had not yet been called are never
       executed
 The JavaScript setter functions have the signature:
 <pre>
 <b>this</b>.function(name, newValue, oldValue, exception)
     <b>this</b> is set to the object whose field changed value
     name is the name of the field that changed value
     newValue is the new value of the field
     oldValue was the value of the field before the assignment
     exception is non-null when a value is being reverted
 </pre>

 The new value is assigned to the field before the setter is called. 
 So, newValue is not strictly needed; it can also be obtained by simply
 reading the value of the field associated with the setter.

 Following normal JavaScript conventions, unneeded arguments can be
 omitted from the declaration. So all of the following are valid
 declarations for a setter function:
 <pre>
 function(name, newValue, oldValue) {}
 function(name, newValue) {}
 function(name) {}
 function() {}
 </pre></div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../serialized-form.html#xdc.services.getset.Setters">Serialized Form</a></dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== PROPERTY SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="property_summary">
<!--   -->
</a>
<h3>Property Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="properties_inherited_from_class_org.mozilla.javascript.BaseFunction">
<!--   -->
</a>
<h3>Properties inherited from class&nbsp;org.mozilla.javascript.BaseFunction</h3>
<code>hasPrototypeProperty</code></li>
</ul>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_org.mozilla.javascript.ScriptableObject">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;org.mozilla.javascript.ScriptableObject</h3>
<code>CONST, DONTENUM, EMPTY, PERMANENT, READONLY, UNINITIALIZED_CONST</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_org.mozilla.javascript.Scriptable">
<!--   -->
</a>
<h3>Fields inherited from interface&nbsp;org.mozilla.javascript.Scriptable</h3>
<code>NOT_FOUND</code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../xdc/services/getset/Setters.html#Setters(java.lang.Object)">Setters</a></strong>(java.lang.Object&nbsp;member)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#addGlobal(org.mozilla.javascript.Callable)">addGlobal</a></strong>(org.mozilla.javascript.Callable&nbsp;setter)</code>
<div class="block">Add a setter that is called when any field changes value.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.Object</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#call(org.mozilla.javascript.Context, org.mozilla.javascript.Scriptable, org.mozilla.javascript.Scriptable, java.lang.Object[])">call</a></strong>(org.mozilla.javascript.Context&nbsp;cx,
    org.mozilla.javascript.Scriptable&nbsp;scope,
    org.mozilla.javascript.Scriptable&nbsp;thisObj,
    java.lang.Object[]&nbsp;args)</code>
<div class="block">The master setter function called by XDCscript.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#getMaxStackDepth()">getMaxStackDepth</a></strong>()</code>
<div class="block">Get the maximum allowed depth of recursively nested setters.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.util.Set&lt;org.mozilla.javascript.Callable&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#init(xdc.services.intern.xsr.Value.Observable, int)">init</a></strong>(xdc.services.intern.xsr.Value.Observable&nbsp;obj,
    int&nbsp;index)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.util.Set&lt;org.mozilla.javascript.Callable&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#init(xdc.services.intern.xsr.Value.Observable, java.lang.String)">init</a></strong>(xdc.services.intern.xsr.Value.Observable&nbsp;obj,
    java.lang.String&nbsp;name)</code>
<div class="block">Add setter support to a field of an object.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../xdc/services/getset/Setters.html#setMaxStackDepth(int)">setMaxStackDepth</a></strong>(int&nbsp;maxStackDepth)</code>
<div class="block">Set the maximum allowed depth of recursively nested setters, as
 a debugging aid.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.mozilla.javascript.BaseFunction">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.mozilla.javascript.BaseFunction</h3>
<code>construct, createObject, execIdCall, fillConstructorProperties, findInstanceIdInfo, findPrototypeId, getArity, getClassName, getClassPrototype, getFunctionName, getInstanceIdName, getInstanceIdValue, getLength, getMaxInstanceId, getPrototypeProperty, getTypeOf, hasInstance, hasPrototypeProperty, initPrototypeId, setImmunePrototypeProperty, setInstanceIdValue</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.mozilla.javascript.IdScriptableObject">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.mozilla.javascript.IdScriptableObject</h3>
<code>activatePrototypeMap, addIdFunctionProperty, defaultGet, defaultPut, defineOwnProperty, delete, exportAsJSClass, get, getAttributes, getOwnPropertyDescriptor, has, hasPrototypeMap, incompatibleCallError, initPrototypeConstructor, initPrototypeMethod, initPrototypeValue, instanceIdInfo, put, setAttributes, setInstanceIdAttributes</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.mozilla.javascript.ScriptableObject">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.mozilla.javascript.ScriptableObject</h3>
<code>applyDescriptorToAttributeBitset, associateValue, avoidObjectDetection, buildDataDescriptor, callMethod, callMethod, checkPropertyChange, checkPropertyDefinition, defineClass, defineClass, defineClass, defineConst, defineConstProperty, defineFunctionProperties, defineOwnProperties, defineOwnProperty, defineProperty, defineProperty, defineProperty, defineProperty, delete, deleteProperty, deleteProperty, ensureScriptable, ensureScriptableObject, equivalentValues, get, get, getAllIds, getArrayPrototype, getAssociatedValue, getAttributes, getAttributes, getAttributes, getClassPrototype, getDefaultValue, getDefaultValue, getFunctionPrototype, getGetterOrSetter, getIds, getObjectPrototype, getParentScope, getProperty, getProperty, getPropertyIds, getPrototype, getSlot, getTopLevelScope, getTopScopeValue, getTypedProperty, getTypedProperty, has, hasProperty, hasProperty, isAccessorDescriptor, isConst, isDataDescriptor, isEmpty, isExtensible, isFalse, isGenericDescriptor, isGetterOrSetter, isSealed, isTrue, preventExtensions, put, putConst, putConstProperty, putProperty, putProperty, redefineProperty, sameValue, sealObject, setAttributes, setAttributes, setAttributes, setGetterOrSetter, setParentScope, setPrototype, size</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.mozilla.javascript.Scriptable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.mozilla.javascript.Scriptable</h3>
<code>delete, delete, get, get, getDefaultValue, getIds, getParentScope, getPrototype, has, has, put, put, setParentScope, setPrototype</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Setters(java.lang.Object)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Setters</h4>
<pre>public&nbsp;Setters(java.lang.Object&nbsp;member)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="init(xdc.services.intern.xsr.Value.Observable, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>init</h4>
<pre>public static&nbsp;java.util.Set&lt;org.mozilla.javascript.Callable&gt;&nbsp;init(xdc.services.intern.xsr.Value.Observable&nbsp;obj,
                                                  java.lang.String&nbsp;name)</pre>
<div class="block">Add setter support to a field of an object.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The set of user setters for the field.</dd></dl>
</li>
</ul>
<a name="init(xdc.services.intern.xsr.Value.Observable, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>init</h4>
<pre>public static&nbsp;java.util.Set&lt;org.mozilla.javascript.Callable&gt;&nbsp;init(xdc.services.intern.xsr.Value.Observable&nbsp;obj,
                                                  int&nbsp;index)</pre>
</li>
</ul>
<a name="call(org.mozilla.javascript.Context, org.mozilla.javascript.Scriptable, org.mozilla.javascript.Scriptable, java.lang.Object[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>call</h4>
<pre>public&nbsp;java.lang.Object&nbsp;call(org.mozilla.javascript.Context&nbsp;cx,
                    org.mozilla.javascript.Scriptable&nbsp;scope,
                    org.mozilla.javascript.Scriptable&nbsp;thisObj,
                    java.lang.Object[]&nbsp;args)</pre>
<div class="block">The master setter function called by XDCscript. First calls all
 the global setters, then calls the individual setters registered
 on this field.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>call</code>&nbsp;in interface&nbsp;<code>org.mozilla.javascript.Callable</code></dd>
<dt><strong>Specified by:</strong></dt>
<dd><code>call</code>&nbsp;in interface&nbsp;<code>org.mozilla.javascript.Function</code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code>call</code>&nbsp;in class&nbsp;<code>org.mozilla.javascript.BaseFunction</code></dd>
</dl>
</li>
</ul>
<a name="addGlobal(org.mozilla.javascript.Callable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addGlobal</h4>
<pre>public static&nbsp;void&nbsp;addGlobal(org.mozilla.javascript.Callable&nbsp;setter)</pre>
<div class="block">Add a setter that is called when any field changes value.</div>
</li>
</ul>
<a name="getMaxStackDepth()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaxStackDepth</h4>
<pre>public static&nbsp;int&nbsp;getMaxStackDepth()</pre>
<div class="block">Get the maximum allowed depth of recursively nested setters.</div>
</li>
</ul>
<a name="setMaxStackDepth(int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setMaxStackDepth</h4>
<pre>public static&nbsp;void&nbsp;setMaxStackDepth(int&nbsp;maxStackDepth)</pre>
<div class="block">Set the maximum allowed depth of recursively nested setters, as
 a debugging aid.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../xdc/services/getset/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../xdc/services/getset/Scheduler.html" title="class in xdc.services.getset"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?xdc/services/getset/Setters.html" target="_top">Frames</a></li>
<li><a href="Setters.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields_inherited_from_class_org.mozilla.javascript.ScriptableObject">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
